package DataSetNodes;
use Switch;
use DBI;

$CommitCounter = 0;
$VERSION = 0.0.2;
sub new
{
    my $self = {};
    bless $self;
    $self    = shift;      # Instanzoverhead
    my ($extData) = shift; # Benoetigte Daten
    
    $dbargs = {AutoCommit => 0,
               PrintError => 0};
    $dbh = DBI->connect("dbi:SQLite:dbname=$extData","","",$dbargs);
    $dbh->do("PRAGMA synchronous=0");
    $dbh->do("PRAGMA journal_mode = off");    
    $dbh->do("PROFILE ON");
    $dbh->do("PRAGMA encoding = 'UTF-8'");

    ResetVarsNodes();
    return $self;
}

#############################################################################
# Aufteilen der Zeile in Nodes 
#############################################################################
sub CrunchLine
{
  my ($self)    = shift; # Instanzoverhead
  $extData = shift;      # Benoetigte Daten
  
  if ($extData  =~ /<node id=\"(.+?)\"/)
  {
  	SetNodeIDTo($1);
  }
  if ($extData  =~ / lat=\"(.+?)\" /)
  {
  	SetLatitudeTo($1);
  }
  if ($extData  =~ / lon=\"(.+?)\" /)
  {
  	SetLongitudeTo($1);
  }
  # -------------------------------------------------------------------------
  if ($extData  =~ /<tag k=\"(.+?)\" v=\"(.+?)\"/)
  {
  	SetAttributes($1,$2);
  	return 1;
  }
  # -------------------------------------------------------------------------
  if ($extData  =~ /<node .+?\/>/i) { SchliesseDatensatzAb(); return 99; }
  if ($extData  =~ /<node .+?\">/i) { return 1; }
  if ($extData  =~ /<\/node/i)      { SchliesseDatensatzAb(); return 99; }  
  if ($extData  =~ /<\/node>/i)     { SchliesseDatensatzAb(); return 99; }
  return 0;
}
#############################################################################
sub SetNodeIDTo
{
  my ($extData) = shift; # Benoetigte Daten
  $NodeID = $extData;
}
#############################################################################
sub SetLongitudeTo
{
  my ($extData) = shift; # Benoetigte Daten
  $Lon = $extData;
}
#############################################################################
sub SetLatitudeTo
{
  my ($extData) = shift; # Benoetigte Daten
  $Lat = $extData;
}
#############################################################################
sub SetAttributes
{
  my ($extKey) = shift;    # Benoetigte Daten
  my ($extVal) = shift;    # Benoetigte Daten

  ####
  # Bestimmte Attribute sollen nicht gespeichert werden
  ####
#  switch ($extKey) {
#   case "randomjunk_bot" 	{ return 0; }
#   case "created_by"     	{ return 0; }
#    case "fixme"          	{ return 0; }
#    case "source"      	  	{ return 0; }
#    case "ele"            	{ return 0; } # Elevation, actually not really needed and working
#    case "note"           	{ return 0; }
#    case "irc"            	{ return 0; }
#    case "source:position" 	{ return 0; }
#    case "website"		      { return 0; }
#    case "site"   		      { return 0; }
#    case "usgs:id"  	      { return 0; }
#    case "www"      	      { return 0; }
#    case "facebook"  	      { return 0; }
#    case "name:th"  	      { return 0; }
#    case "name:ja"  	      { return 0; }
#    case "official_name:el" { return 0; }
#  }
  
#  return 0 if ($extKey =~ /wikipedia/);
#  return 0 if ($extKey =~ /seamark/);
#  return 0 if ($extKey =~ /source/);
  
  $Attr{$extKey} = $extVal;
}
#############################################################################
sub ResetVarsNodes
{
        $NodeID = 0;
        $Lat    = 0;
        $Lon    = 0;
        %Attr   = ();
}
#############################################################################
sub SchliesseDatensatzAb
{
	$SQL = "INSERT INTO Nodes(ID,Lat,Lon) VALUES ($NodeID,$Lat,$Lon)";
  $dbh->do($SQL);
  
	while ( ($k,$v) = each %Attr ) {
		$SQL = "INSERT INTO Attr(ID,k,v) VALUES ($NodeID, '$k', '$v')";
		$dbh->do($SQL);
  }
  $dbh->commit();
  ResetVarsNodes();
}
1;
