package DataSetRel;
use DBI;
$VERSION = 0.0.2;
$DBName = 'nodes.db';
sub new
{
    my $self = {};
    bless $self;
    $self         = shift; # Instanzoverhead
    my ($extData) = shift; # Benoetigte Daten

    $dbargs = {AutoCommit => 0,
               PrintError => 1};

    $dbh = DBI->connect("dbi:SQLite:dbname=$extData","","",$dbargs);
    $dbh->do("PRAGMA synchronous=0");
    $dbh->do("PRAGMA journal_mode = off");
    $dbh->do("PRAGMA encoding = 'UTF-8'");

    ResetVarsRel();
    return $self;
}

#############################################################################
# Aufteilen der Zeile in Nodes 
#############################################################################
sub CrunchLine
{
  my ($self)    = shift; # Instanzoverhead
  my ($extData) = shift; # Benoetigte Daten
  
  if ($extData  =~ /<relation id=\"(.+?)\"/)
  {
  	SetRelIDTo($1);
  	return 1;
  }
  if ($extData  =~ /<member type=\"(.+?)\" ref=\"(.+?)\" role=\"(.+?)\"\/>/)
  {
  	SetNewMemberType($1,$2,$3);
  	return 1;
  }
  if ($extData  =~ /<member type=\"(.+?)\" ref=\"(.+?)\" role=\"\"\/>/)
  {
  	SetNewMemberType($1,$2,"");
  	return 1;
  }
  # -------------------------------------------------------------------------
  if ($extData  =~ /<tag k=\"(.+?)\" v=\"(.+?)\"/)
  {
  	SetAttributes($1,$2);
  	return 1;
  }
  # -------------------------------------------------------------------------
  if ($extData  =~ /<\/relation>/i)      { SchliesseDatensatzAb(); return 99; }
  return 0;
}
#############################################################################
sub SetRelIDTo
{
  my ($extData) = shift; # Benoetigte Daten
  $RelID = $extData;
  return 0;
}
#############################################################################
sub SetNewMemberType
{
  my ($typ,$ref,$role) = @_; # Benoetigte Daten
  my (%tmp);
  
  $tmp{'role'} = $role;
  $tmp{'ref'}  = $ref;
  $tmp{'typ'}  = $typ;
  
  push(@Rel, \%tmp);
  
  return 0;
}
#############################################################################
sub SetAttributes
{
  my ($extKey) = shift;    # Benoetigte Daten
  my ($extVal) = shift;    # Benoetigte Daten
  $Attr{$extKey} = $extVal;
  return 0;
}
#############################################################################
sub ResetVarsRel
{
        $RelID  = 0;
        %Attr   = ();
        undef (@Rel);     
}
#############################################################################
sub SchliesseDatensatzAb
{
  for ($i = 0; $i <= $#Rel; $i++)
  {
    $tmp = $Rel[$i];
    $role = $tmp->{'role'};
    $ref  = $tmp->{'ref'};
    $typ  = $tmp->{'typ'};
    $SQL = "INSERT INTO Relations(ID,Role,Ref,Type) VALUES ($RelID,'$role',$ref,'$typ')";
    $dbh->do($SQL);        
  }
	while ( ($k,$v) = each %Attr ) {
		$SQL = "INSERT INTO RelationsAttr(ID,k,v) VALUES ($RelID, '$k', '$v')";
		$dbh->do($SQL);
  }
  $dbh->commit();
  ResetVarsRel();
}
1;
